package top.littlerich.virtuallocation.common;

import android.Manifest;
import android.app.Application;
import android.app.Service;
import android.content.pm.PackageManager;
import android.os.Vibrator;

import com.baidu.mapapi.CoordType;
import com.baidu.mapapi.SDKInitializer;

import top.littlerich.virtuallocation.model.Gps;
import top.littlerich.virtuallocation.service.LocationService;
import top.littlerich.virtuallocation.util.PermissionUtil;

/**
 * Created by xuqingfu on 2017/4/15.
 */
public class AppApplication extends Application {
    public LocationService locationService;
    public Vibrator mVibrator;

    /**
     * 全局GPS
     */
    public static Gps mMockGps;

    static {
        mMockGps = Config.COMPANY;
    }

    @Override
    public void onCreate() {
        super.onCreate();
        /***
         * 初始化定位sdk，建议在Application中创建
         */
        locationService = new LocationService(getApplicationContext());
        mVibrator = (Vibrator) getApplicationContext().getSystemService(Service.VIBRATOR_SERVICE);

        if (PermissionUtil.checkPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            // 在使用 SDK 各组间之前初始化 context 信息，传入 ApplicationContext
            SDKInitializer.initialize(this);
            SDKInitializer.setCoordType(CoordType.BD09LL);
        }


    }

}